diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 4e9743ab01a..61eed8dd5a2 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -2547,6 +2547,7 @@ heap_get_latest_tid(Relation relation,
 		 */
 		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
 			HeapTupleHeaderIsOnlyLocked(tp.t_data) ||
+			HeapTupleHeaderIndicatesSplitUpdate(tp.t_data) ||
 			ItemPointerEquals(&tp.t_self, &tp.t_data->t_ctid))
 		{
 			UnlockReleaseBuffer(buffer);
@@ -3379,6 +3380,7 @@ xmax_infomask_changed(uint16 new_infomask, uint16 old_infomask)
 HTSU_Result
 heap_delete(Relation relation, ItemPointer tid,
 			CommandId cid, Snapshot crosscheck, bool wait,
+			bool is_splitupdate,
 			HeapUpdateFailureData *hufd)
 {
 	HTSU_Result result;
@@ -3652,6 +3654,10 @@ heap_delete(Relation relation, ItemPointer tid,
 	/* Make sure there is no forward chain link in t_ctid */
 	tp.t_data->t_ctid = tp.t_self;
 
+	/* Signal that this is actually a move into another segment */
+	if (is_splitupdate)
+		HeapTupleHeaderSetSplitUpdate(tp.t_data);
+
 	MarkBufferDirty(buffer);
 
 	/*
@@ -3777,6 +3783,7 @@ simple_heap_delete(Relation relation, ItemPointer tid)
 	result = heap_delete(relation, tid,
 						 GetCurrentCommandId(true), InvalidSnapshot,
 						 true /* wait for commit */ ,
+						 false /* is_splitupdate cannot be true */ ,
 						 &hufd);
 	switch (result)
 	{
@@ -6354,6 +6361,7 @@ heap_lock_updated_tuple_rec(Relation rel, ItemPointer tid, TransactionId xid,
 next:
 		/* if we find the end of update chain, we're done. */
 		if (mytup.t_data->t_infomask & HEAP_XMAX_INVALID ||
+			HeapTupleHeaderIndicatesSplitUpdate(mytup.t_data) ||
 			ItemPointerEquals(&mytup.t_self, &mytup.t_data->t_ctid) ||
 			HeapTupleHeaderIsOnlyLocked(mytup.t_data))
 		{
@@ -6407,7 +6415,8 @@ static HTSU_Result
 heap_lock_updated_tuple(Relation rel, HeapTuple tuple, ItemPointer ctid,
 						TransactionId xid, LockTupleMode mode)
 {
-	if (!ItemPointerEquals(&tuple->t_self, ctid))
+	if (!HeapTupleHeaderIndicatesSplitUpdate(tuple->t_data) &&
+		!ItemPointerEquals(&tuple->t_self, ctid))
 	{
 		/*
 		 * If this is the first possibly-multixact-able operation in the
diff --git a/src/backend/access/heap/rewriteheap.c b/src/backend/access/heap/rewriteheap.c
index e7c764a42b0..da2ef21fbd3 100644
--- a/src/backend/access/heap/rewriteheap.c
+++ b/src/backend/access/heap/rewriteheap.c
@@ -424,6 +424,7 @@ rewrite_heap_tuple(RewriteState state,
 	 */
 	if (!((old_tuple->t_data->t_infomask & HEAP_XMAX_INVALID) ||
 		  HeapTupleHeaderIsOnlyLocked(old_tuple->t_data)) &&
+		!HeapTupleHeaderIndicatesSplitUpdate(old_tuple->t_data) &&
 		!(ItemPointerEquals(&(old_tuple->t_self),
 							&(old_tuple->t_data->t_ctid))))
 	{
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index fe4518a928a..7c90a43634d 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -2829,6 +2829,11 @@ ltrmark:;
 					ereport(ERROR,
 							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 							 errmsg("could not serialize access due to concurrent update")));
+				if (ItemPointerIndicatesSplitUpdate(&hufd.ctid))
+					ereport(ERROR,
+							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+							 errmsg("tuple to be updated was already moved to another segment due to concurrent update")));
+
 				if (!ItemPointerEquals(&hufd.ctid, &tuple.t_self))
 				{
 					/* it was updated, so look at the updated version */
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index c14503f4cf6..72d9eb2eee4 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -3835,6 +3835,10 @@ EvalPlanQualFetch(EState *estate, Relation relation, int lockmode,
 						ereport(ERROR,
 								(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 								 errmsg("could not serialize access due to concurrent update")));
+					if (ItemPointerIndicatesSplitUpdate(&hufd.ctid))
+						ereport(ERROR,
+								(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+								 errmsg("tuple to be updated was already moved to another segment due to concurrent update")));
 
 					/* Should not encounter speculative tuple on recheck */
 					Assert(!HeapTupleHeaderIsSpeculative(tuple.t_data));
@@ -3904,6 +3908,13 @@ EvalPlanQualFetch(EState *estate, Relation relation, int lockmode,
 		 * As above, it should be safe to examine xmax and t_ctid without the
 		 * buffer content lock, because they can't be changing.
 		 */
+
+		/* check whether next version would be in a different segment */
+		if (HeapTupleHeaderIndicatesSplitUpdate(tuple.t_data))
+			ereport(ERROR,
+					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+					 errmsg("tuple to be locked was already moved to another segment due to concurrent update")));
+
 		if (ItemPointerEquals(&tuple.t_self, &tuple.t_data->t_ctid))
 		{
 			/* deleted, so forget about it */
diff --git a/src/backend/executor/nodeLockRows.c b/src/backend/executor/nodeLockRows.c
index dba610f0a95..764898aa548 100644
--- a/src/backend/executor/nodeLockRows.c
+++ b/src/backend/executor/nodeLockRows.c
@@ -219,6 +219,10 @@ ExecLockRows(LockRowsState *node)
 					ereport(ERROR,
 							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 							 errmsg("could not serialize access due to concurrent update")));
+				if (ItemPointerIndicatesSplitUpdate(&hufd.ctid))
+					ereport(ERROR,
+							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+							 errmsg("tuple to be updated was already moved to another segment due to concurrent update")));
 				if (ItemPointerEquals(&hufd.ctid, &tuple.t_self))
 				{
 					/* Tuple was deleted, so don't return it */
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index 5ace999bc67..9e075eaef0d 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -940,6 +940,11 @@ ldelete:;
 							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 							 errmsg("could not serialize access due to concurrent update")));
 
+				if (ItemPointerIndicatesSplitUpdate(&hufd.ctid))
+					ereport(ERROR,
+							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+							 errmsg("tuple to be %s was already moved to another segment due to concurrent update",
+									isUpdate ? "updated" : "deleted")));
 				/*
 				 * If GDD is enabled and the DELETE operator is generated by
 				 * SplitUpdate node (SplitUpdate node is generated for updating
@@ -1475,6 +1480,11 @@ ExecUpdate(ItemPointer tupleid,
 					ereport(ERROR,
 							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 									errmsg("could not serialize access due to concurrent update")));
+				if (ItemPointerIndicatesSplitUpdate(&hufd.ctid))
+					ereport(ERROR,
+							(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
+							 errmsg("tuple to be updated was already moved to another segment due to concurrent update")));
+
 				if (!ItemPointerEquals(tupleid, &hufd.ctid))
 				{
 					TupleTableSlot *epqslot;
@@ -1649,6 +1659,7 @@ ExecOnConflictUpdate(ModifyTableState *mtstate,
 						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
 						 errmsg("could not serialize access due to concurrent update")));
 
+			Assert(!ItemPointerIndicatesSplitUpdate(&hufd.ctid));
 			/*
 			 * Tell caller to try again from the very start.
 			 *
@@ -2884,7 +2895,7 @@ table_delete(ResultRelInfo *resultRelInfo, EState *estate, bool isUpdate,
 		result = heap_delete(resultRelationDesc, tupleid,
 							 cid,
 							 crosscheck_snapshot,
-							 wait,
+							 wait, isUpdate,
 							 hufd);
 	}
 	else if (RelationIsAoRows(resultRelationDesc))
diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index 44760b7b397..52d937014ad 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -165,7 +165,7 @@ extern Oid heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 extern void heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
 				  CommandId cid, int options, BulkInsertState bistate, TransactionId xid);
 extern HTSU_Result heap_delete(Relation relation, ItemPointer tid,
-			CommandId cid, Snapshot crosscheck, bool wait,
+							   CommandId cid, Snapshot crosscheck, bool wait, bool is_splitupdate,
 			HeapUpdateFailureData *hufd);
 extern void heap_finish_speculative(Relation relation, HeapTuple tuple);
 extern void heap_abort_speculative(Relation relation, HeapTuple tuple);
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
index 8ab95e42d82..e9582216118 100644
--- a/src/include/access/htup_details.h
+++ b/src/include/access/htup_details.h
@@ -84,7 +84,9 @@
  *
  * A word about t_ctid: whenever a new tuple is stored on disk, its t_ctid
  * is initialized with its own TID (location).  If the tuple is ever updated,
- * its t_ctid is changed to point to the replacement version of the tuple.
+ * its t_ctid is changed to point to the replacement version of the tuple or
+ * the block number (ip_blkid) is invalidated if the tuple is moved from one
+ * segment to another segment due to update on the distributed keys of a table.
  * Thus, a tuple is the latest version of its row iff XMAX is invalid or
  * t_ctid points to itself (in which case, if XMAX is valid, the tuple is
  * either locked or deleted).  One can follow the chain of t_ctid links
@@ -444,6 +446,12 @@ do { \
 	ItemPointerSet(&(tup)->t_ctid, token, SpecTokenOffsetNumber) \
 )
 
+#define HeapTupleHeaderSetSplitUpdate(tup) \
+	ItemPointerSetSplitUpdate(&(tup)->t_ctid)
+
+#define HeapTupleHeaderIndicatesSplitUpdate(tup) \
+	ItemPointerIndicatesSplitUpdate(&tup->t_ctid)
+
 #define HeapTupleHeaderGetDatumLength(tup) \
 	VARSIZE(tup)
 
diff --git a/src/include/storage/itemptr.h b/src/include/storage/itemptr.h
index f8090f3a5f9..34de93178b6 100644
--- a/src/include/storage/itemptr.h
+++ b/src/include/storage/itemptr.h
@@ -51,6 +51,22 @@ ItemPointerData;
 
 typedef ItemPointerData *ItemPointer;
 
+/* ----------------
+ *		special values used in heap tuples (t_ctid)
+ * ----------------
+ */
+
+/*
+ * Greenplum specific behavior:
+ * When a tuple is moved to a different segment by UPDATE on distkeys
+ * (greenplum implements this using split update techniques), the t_ctid
+ * of the deleted tuple is set to this magic value.
+ *
+ * NB: later version of Postgres use 0xfffc and 0xfffe.
+ */
+#define SplitUpdateOffsetNumber 0xffff
+#define SplitUpdateBlockNumber	InvalidBlockNumber
+
 /* ----------------
  *		support macros
  * ----------------
@@ -63,6 +79,15 @@ typedef ItemPointerData *ItemPointer;
 #define ItemPointerIsValid(pointer) \
 	((bool) (PointerIsValid(pointer) && ((pointer)->ip_posid != 0)))
 
+/*
+ * ItemPointerGetBlockNumberNoCheck
+ *		Returns the block number of a disk item pointer.
+ */
+#define ItemPointerGetBlockNumberNoCheck(pointer) \
+( \
+	BlockIdGetBlockNumber(&(pointer)->ip_blkid) \
+)
+
 /*
  * ItemPointerGetBlockNumber
  *		Returns the block number of a disk item pointer.
@@ -139,6 +164,23 @@ typedef ItemPointerData *ItemPointer;
 	(pointer)->ip_posid = InvalidOffsetNumber \
 )
 
+/*
+ * ItemPointerIndicatesSplitUpdate
+ *		True iff the block number indicates the tuple has moved to another
+ *		partition.
+ */
+#define ItemPointerIndicatesSplitUpdate(pointer) \
+	!BlockNumberIsValid(ItemPointerGetBlockNumberNoCheck(pointer))
+
+/*
+ * ItemPointerSetMovedPartitions
+ *		Indicate that the item referenced by the itempointer has moved into a
+ *		different partition.
+ */
+#define ItemPointerSetSplitUpdate(pointer) \
+	ItemPointerSetBlockNumber((pointer), InvalidBlockNumber)
+
+
 /* ----------------
  *		externs
  * ----------------
diff --git a/src/test/isolation2/expected/concurrent_update_distkeys.out b/src/test/isolation2/expected/concurrent_update_distkeys.out
index 5330c5b2a8e..e65fde58d43 100644
--- a/src/test/isolation2/expected/concurrent_update_distkeys.out
+++ b/src/test/isolation2/expected/concurrent_update_distkeys.out
@@ -118,7 +118,7 @@ UPDATE 1
 1: end;
 END
 2<:  <... completed>
-ERROR:  concurrent updates distribution keys on the same row is not allowed  (seg2 127.0.0.1:25434 pid=33685)
+ERROR:  tuple to be updated was already moved to another segment due to concurrent update  (seg1 127.0.1.1:7003 pid=74220)
 2: end;
 END
 0: select * from tab_update_hashcol;
@@ -165,6 +165,86 @@ DROP
 2q: ... <quitting>
 0q: ... <quitting>
 
+-- split update is to implement updating on hash keys,
+-- it deletes the tuple and insert a new tuple in a
+-- new segment, so it is not easy for other transaction
+-- to follow the update link to fetch the new tuple. The
+-- other transaction should raise error for such case.
+-- the following case should be tested with GDD enabled.
+-- See github issue: https://github.com/greenplum-db/gpdb/issues/8919
+
+create table t_splitupdate_raise_error (a int, b int) distributed by (a);
+CREATE
+insert into t_splitupdate_raise_error values (1, 1);
+INSERT 1
+
+-- test delete will throw error
+1: begin;
+BEGIN
+1: update t_splitupdate_raise_error set a = a + 1;
+UPDATE 1
+
+2: begin;
+BEGIN
+2&: delete from t_splitupdate_raise_error;  <waiting ...>
+
+1: end;
+END
+2<:  <... completed>
+ERROR:  tuple to be deleted was already moved to another segment due to concurrent update  (seg1 127.0.1.1:7003 pid=32174)
+
+2: abort;
+ABORT
+1q: ... <quitting>
+2q: ... <quitting>
+
+-- test norm update will throw error
+1: begin;
+BEGIN
+1: update t_splitupdate_raise_error set a = a + 1;
+UPDATE 1
+
+2: begin;
+BEGIN
+2&: update t_splitupdate_raise_error set b = 999;  <waiting ...>
+
+1: end;
+END
+2<:  <... completed>
+ERROR:  tuple to be updated was already moved to another segment due to concurrent update  (seg0 127.0.1.1:7002 pid=74282)
+
+2: abort;
+ABORT
+1q: ... <quitting>
+2q: ... <quitting>
+
+-- select for update might lock tuples on segments,
+-- and wait for the XID lock held by splitupdate transaction,
+-- it should also raise an error because it is not easy to
+-- follow the update link to a new segment.
+-- set optimizer off for this case is because orca does not
+-- generate lockrows plannode.
+1: begin;
+BEGIN
+1: update t_splitupdate_raise_error set a = a + 1;
+UPDATE 1
+
+2: begin;
+BEGIN
+2: set optimizer = off;
+SET
+2&: select * from t_splitupdate_raise_error for update;  <waiting ...>
+
+1: end;
+END
+2<:  <... completed>
+ERROR:  tuple to be updated was already moved to another segment due to concurrent update  (seg0 slice1 127.0.1.1:7002 pid=32220)
+
+2: abort;
+ABORT
+1q: ... <quitting>
+2q: ... <quitting>
+
 -- disable gdd
 -- start_ignore
 ! gpconfig -c gp_enable_global_deadlock_detector -v off;
diff --git a/src/test/isolation2/sql/concurrent_update_distkeys.sql b/src/test/isolation2/sql/concurrent_update_distkeys.sql
index 7f6c5b9975a..d47c99d271b 100644
--- a/src/test/isolation2/sql/concurrent_update_distkeys.sql
+++ b/src/test/isolation2/sql/concurrent_update_distkeys.sql
@@ -88,6 +88,65 @@
 2q:
 0q:
 
+-- split update is to implement updating on hash keys,
+-- it deletes the tuple and insert a new tuple in a
+-- new segment, so it is not easy for other transaction
+-- to follow the update link to fetch the new tuple. The
+-- other transaction should raise error for such case.
+-- the following case should be tested with GDD enabled.
+-- See github issue: https://github.com/greenplum-db/gpdb/issues/8919
+
+create table t_splitupdate_raise_error (a int, b int) distributed by (a);
+insert into t_splitupdate_raise_error values (1, 1);
+
+-- test delete will throw error
+1: begin;
+1: update t_splitupdate_raise_error set a = a + 1;
+
+2: begin;
+2&: delete from t_splitupdate_raise_error;
+
+1: end;
+2<:
+
+2: abort;
+1q:
+2q:
+
+-- test norm update will throw error
+1: begin;
+1: update t_splitupdate_raise_error set a = a + 1;
+
+2: begin;
+2&: update t_splitupdate_raise_error set b = 999;
+
+1: end;
+2<:
+
+2: abort;
+1q:
+2q:
+
+-- select for update might lock tuples on segments,
+-- and wait for the XID lock held by splitupdate transaction,
+-- it should also raise an error because it is not easy to
+-- follow the update link to a new segment.
+-- set optimizer off for this case is because orca does not
+-- generate lockrows plannode.
+1: begin;
+1: update t_splitupdate_raise_error set a = a + 1;
+
+2: begin;
+2: set optimizer = off;
+2&: select * from t_splitupdate_raise_error for update;
+
+1: end;
+2<:
+
+2: abort;
+1q:
+2q:
+
 -- disable gdd
 -- start_ignore
 ! gpconfig -c gp_enable_global_deadlock_detector -v off;
